- connection: local
  gather_facts: false
  hosts: localhost
  vars:
    path: /tmp/cqaso-web-master/
    id_rsa: ../.ssh_rsa
    Thost: 10.47.108.240
    Tuser: root
    AppName: cqaso-web
    version: master
    port: 8000
    repo: git@gitlab.com:chuangqi/cqaso-web.git
  tasks:
    - name: 检测{{ path }}是否存在
      shell: ls {{ path }} || mkdir {{ path }}

    - name: Update {{ AppName }}-{{ version }}  from gitlab.
      git:
        clone: true
        dest: "{{ path }}"
        force: true
        key_file: "{{ id_rsa }}"
        repo: "{{ repo }}"
        ssh_opts: -o StrictHostKeyChecking=no
        update: true
        version: "{{ version }}"
      register: gitClone_out
    
    - name: Install dependencies {{ AppName }} packages with yarn
      shell: yarn install --force
      args:
        chdir: "{{ path }}"
      register: yinstall_out
      
    - name: print yarn install result
      debug: var=yinstall_out.stdout verbosity=0
      
    - name: webpack cqaso-web
      shell: yarn run build
      args:
        chdir: "{{ path }}"
      register: yrun_out
      when: yinstall_out["rc"] == 0

    - name: 相关文件的归档
      shell: tar -zcvf /tmp/release/{{ AppName }}-{{ version }}-new.tar.gz dist static package.json ecosystem.config.js
      args:
        chdir: "{{ path }}"
    
    - name: 拷贝相关文件到生产机器
      shell: scp -P6677 /tmp/release/{{ AppName }}-{{ version }}-new.tar.gz {{ Tuser }}@{{ Thost }}:/root;
      args:
        chdir: "{{ path }}"

    - name: new version archive
      shell: mv {{ AppName }}-{{ version }}-new.tar.gz  {{ AppName }}-{{ version }}-new-`date +%Y%m%d%H%M%S`
      args:
        chdir: /tmp/release/
